;############################################ Load Objects

;### Load Achievements

Function set_achievements()
	Local in$,var$,val$
	Local i,equal
	Local stream
	Local file$

	Local dir=ReadDir("sys")
	If dir=0 Then RuntimeError("Unable to read sys dir")
	Repeat
		file$=NextFile(dir)
		If Left(file$,12)="achievements" And Lower(Right(file$,4))=".inf" Then	
	
			stream=ReadFile("sys\"+file$)
			If stream=0 Then RuntimeError("Unable to read sys\"+file$)
			While Not Eof(stream)
				in$=ReadLine(stream)
				equal=Instr(in$,"=")
				If Left(in$,1)="#" Then equal=0
				If equal>0 Then
					var$=Trim(Left(in$,equal-1))
					val$=trimspace(Mid(in$,equal+1,-1))
					Select var$
						Case "id"
							achieve_serial=achieve_serial+1
							i=Int(val$)
							If (i<1 Or i>Cachieve_count) Then RuntimeError("ID between 1 and "+Cachieve_count+" expected!")
							For Tachieve.Tachieve=Each Tachieve
								If Tachieve\id=i Then
									RuntimeError("Achievement with ID "+i+" is already defined!")
								EndIf
							Next
							Tachieve.Tachieve=new Tachieve
							Tachieve\id=i
							Tachieve\iconh=gfx_achievedefaulticon
							Tachieve\visible=1
																		
						Case "name" 
							For Tachieve.Tachieve=Each Tachieve
								If Tachieve\id=i Then
									Tachieve\name$=val$
									Exit
								EndIf
							Next	
						
						Case "icon"
							For Tachieve.Tachieve=Each Tachieve
								If Tachieve\id=i Then
									Tachieve\icon$=val$
									If Tachieve\icon$<>0 Then
										If Tachieve\icon$<>gfx_achievedefaulticon Then FreeImage Tachieve\icon$:Tachieve\iconh=0
									EndIf
									Tachieve\iconh=load_res(Tachieve\icon$,Cres_image,0)
									Exit
								EndIf
							Next
							
						Case "count"
							For Tachieve.Tachieve=Each Tachieve
								If Tachieve\id=i Then
									Tachieve\rcount=Int(val$)
									Exit
								EndIf
							Next

						Case "visible"
							For Tachieve.Tachieve=Each Tachieve
								If Tachieve\id=i Then
									Tachieve\visible=Int(val$)
									Exit
								EndIf
							Next

						Case "description"
							If val$="start" Then
								While Not Eof(stream)
									val$=ReadLine(stream)
									If val$="description=end" Then
										Exit
									Else
										For Tachieve.Tachieve=Each Tachieve
											If Tachieve\id=i Then
												Tachieve\descr$=Tachieve\descr$+Trim(val$)+""
												Exit
											EndIf
										Next
									EndIf
								Wend
							EndIf							
				
						Case "script"
							If val$="start" Then
								For Tachieve.Tachieve=Each Tachieve
									If Tachieve\id=i Then
										While Not Eof(stream)
											val$=ReadLine(stream)
											If val$="script=end" Then
												Exit
											Else
												 Tachieve\script$= Tachieve\script$+Trim(val$)+""
											EndIf
										Wend
										Exit
									EndIf
								Next
							EndIf
						Default RuntimeError "Invalid ACHIEVEMENT Property '"+var$+"'"
					End Select
				EndIf
			Wend
			CloseFile(stream)
			
		ElseIf file$="" Then
			Exit
		EndIf
	Forever
	CloseDir(dir)
End Function

set_achievements()

Function load_achievements()
	Local stream=ReadFile("sys\achievements.cfg")
	If stream=0 Then
		RuntimeError "Can't find achievements.cfg"
	Else
		;Load
		ReadLine(stream)
		Tachieve.Tachieve = First Tachieve
		Repeat
			If Eof(Stream) Then Exit
			Tachieve\acount=Int(ReadLine(stream))
			Tachieve = After Tachieve
		Forever
		CloseFile(stream)
	EndIf

	For Tachieve.Tachieve=Each Tachieve
		If Tachieve\rcount>0 and Tachieve\acount<>-1 Then
			If Tachieve\acount<>Tachieve\rcount Then
				If Tachieve\visible=0 Then
					Tachieve\state$="-"
				Else
					Tachieve\state$=Tachieve\acount + "/" + Tachieve\rcount + " " + sm$(220)
				EndIf
			EndIf
		ElseIf Tachieve\rcount=0 and Tachieve\acount<>-1 Then
			If Tachieve\visible=0 Then
				Tachieve\state$="-"
			Else
				Tachieve\state$=sm$(221)
			EndIf
		EndIf

		If Tachieve\acount=-1
			Tachieve\state$=sm$(222)
		EndIf
	Next
End Function

load_achievements()

Function save_achievements()
	Local stream=WriteFile("sys\achievements.cfg")
	If stream=0 Then
		RuntimeError("Can't find achievements.cfg")
	Else
		;Save
		WriteLine(stream,"### "+set_moddir$+" Achievements (Warning: Editing this File may cause Errors)")
		For Tachieve.Tachieve = Each Tachieve
			WriteLine(stream,Str(Tachieve\acount))
		Next
		CloseFile(stream)
	EndIf
End Function